=== debian/changelog ===
blender (2.81.a+dfsg-5) unstable; urgency=medium

  * debian/patches/: patchset updated
    - 0006-fix_padding_on_arm.patch dropped
    - 0006-fix_padding_on_arm-mipsel.patch added

 -- Matteo F. Vescovi <mfv@debian.org>  Tue, 21 Jan 2020 14:51:19 +0100

blender (2.81.a+dfsg-4) unstable; urgency=medium

  * debian/patches/: patchset updated
    - #0001 -> #0004 refreshed
    - 0005-fix_ppc64el_fail.patch added
    - 0006-fix_padding_on_arm.patch added

 -- Matteo F. Vescovi <mfv@debian.org>  Thu, 16 Jan 2020 16:56:21 +0100

blender (2.81.a+dfsg-3) unstable; urgency=medium

  * debian/: OpenSubdiv support enabled (Closes: #939622)

 -- Matteo F. Vescovi <mfv@debian.org>  Tue, 14 Jan 2020 22:12:23 +0100

blender (2.81.a+dfsg-2) unstable; urgency=medium

  * debian/control: enable TBB support on all architectures
  * debian/upstream/metadata: file added

 -- Matteo F. Vescovi <mfv@debian.org>  Tue, 14 Jan 2020 20:15:14 +0100

blender (2.81.a+dfsg-1) unstable; urgency=medium

  * New upstream release
    - debian/patches/: patchset updated
      - #0005 and #0006 dropped (applied upstream)
  * debian/control: missing build-dependencies added
    - libxrandr-dev
    - libxxf86vm-dev
  * debian/watch: gz -> xz for upstream tarball format

 -- Matteo F. Vescovi <mfv@debian.org>  Tue, 14 Jan 2020 00:55:04 +0100

blender (2.80+dfsg-4) unstable; urgency=medium

  [ Ondřej Nový ]
  * Bump Standards-Version to 4.4.1

  [ Matteo F. Vescovi ]
  * debian/rules: explicitly drop OpenSubdiv support
  * debian/control:
    - RRR set
    - b-dep "dh-python" added
    - b-dep "libblosc-dev" added

 -- Matteo F. Vescovi <mfv@debian.org>  Wed, 11 Dec 2019 00:05:12 +0100
