=== debian/rules ===
#!/usr/bin/make -f

INSTDIR = debian/tmp
PY3VERS = $(shell py3versions -dv)

ifeq ($(DEB_HOST_ARCH),i386)
	SETSSE = OFF
else
	SETSSE = ON
endif

ifneq (,$(filter $(DEB_HOST_ARCH),amd64 i386))
	SETVDB = ON
else
	SETVDB = OFF
endif

ifeq ($(DEB_HOST_ARCH),mipsel)
	SETCOLLADA = OFF
else
	SETCOLLADA = ON
endif

override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX=/usr \
		-DCMAKE_SKIP_RPATH=ON \
		-DCMAKE_VERBOSE_MAKEFILE=ON \
		-DFREETYPE_INCLUDE_DIRS="/usr/include/freetype2" \
		-DPYTHON_VERSION=$(PY3VERS) \
		-DWITH_CODEC_FFMPEG=ON \
		-DWITH_CODEC_SNDFILE=ON \
		-DWITH_CPU_SSE=$(SETSSE) \
		-DWITH_CYCLES=ON \
		-DWITH_DOC_MANPAGE=ON \
		-DWITH_FFTW3=ON \
		-DWITH_GAMEENGINE=ON \
		-DWITH_IMAGE_OPENJPEG=ON \
		-DWITH_INPUT_NDOF=ON \
		-DWITH_INSTALL_PORTABLE=OFF \
		-DWITH_JACK=ON \
		-DWITH_MOD_OCEANSIM=ON \
		-DWITH_OPENCOLLADA=$(SETCOLLADA) \
		-DWITH_OPENCOLORIO=ON \
		-DWITH_OPENSUBDIV=ON \
		-DWITH_OPENVDB=$(SETVDB) \
		-DWITH_PLAYER=ON \
		-DWITH_PYTHON_INSTALL=OFF \
		-DWITH_SYSTEM_GLEW=ON \
		-DWITH_SYSTEM_OPENJPEG=ON

override_dh_auto_install:
	dh_auto_install --buildsystem=cmake
	find $(INSTDIR)/usr/share/blender/ -type d -empty -delete

override_dh_missing:
	dh_missing --fail-missing

override_dh_auto_test:

%:
	dh $@ --buildsystem=cmake --with python3
